#include "FKUT/FKUT.h"


// vOn܂main֐
int main(int argc, char *argv[])
{
	// EBhE܁[
	fkut_SimpleWindow	window;			// ϐu3DCG`EBhEɂȂϐv

	window.setSize(800, 600);			// EBhȆ傫͂D݂
	window.setBGColor(0.3, 0.6, 0.8);	// wiFR, G, B̐F0.0`1.0Ńuhč
	window.showGuide();					// ObhƎ̕\
	window.open();						// EBhÊ\
	// EBhE܂

	// \̂pӂĂ镔
	fk_Model			baseModel;
	fkut_GuideObject	baseGuide;

	fkut_ConeModel		body;
	fkut_PrismModel		tireLF, tireRF, tireLB, tireRB;

	body.create(64, 4.0, 20.0);
	body.setMaterial(Yellow);
	body.glMoveTo(0.0, 4.0, 0.0);
	body.glVec(0.0, -2.0, -20.0);
	body.setParent(baseModel, true);
	window.entry(body);
	baseGuide.setScale(1.0);
	baseGuide.setNum(30);
	window.entry(baseModel, baseGuide);
	// entryGuideObject̕ϐꏏɓnƎƏĂ

	tireLF.create(32, 2.0, 2.0, 1.0);
	tireLF.setMaterial(MatBlack);
	tireLF.glMoveTo(-3.0, 2.0, -18.0);
	tireLF.glVec(1.0, 0.0, 0.0);
	tireLF.setParent(body, true);
	window.entry(tireLF);
	tireRF.create(32, 2.0, 2.0, 1.0);
	tireRF.setMaterial(MatBlack);
	tireRF.glMoveTo(3.0, 2.0, -18.0);
	tireRF.glVec(-1.0, 0.0, 0.0);
	tireRF.setParent(body, true);
	window.entry(tireRF);
	tireLB.create(32, 2.0, 2.0, 1.0);
	tireLB.setMaterial(MatBlack);
	tireLB.glMoveTo(-5.0, 2.0, 0.0);
	tireLB.glVec(1.0, 0.0, 0.0);
	tireLB.setParent(body, true);
	window.entry(tireLB);
	tireRB.create(32, 2.0, 2.0, 1.0);
	tireRB.setMaterial(MatBlack);
	tireRB.glMoveTo(5.0, 2.0, 0.0);
	tireRB.glVec(-1.0, 0.0, 0.0);
	tireRB.setParent(body, true);
	window.entry(tireRB);

	body.glTranslate(0.0, 0.0, 10.0);	//ԑ̂̒S傢Ƃ炷

	fkut_BlockModel		floor;			// 킷ubNf

	floor.create(1000.0, 1.0, 1000.0);
	floor.glMoveTo(0.0, -0.51, 0.0);	// 傢ƒ߂ɂĂ
	floor.setMaterial(Brown);
	window.entry(floor);
	// \pӕ܂

	// JOŒ`
	fk_Model	camera;

	window.setCameraModel(camera);
	camera.glMoveTo(0.0, 100.0, 400.0);
	camera.glFocus(0.0, 0.0, 0.0);
	// J`܂

	// TEh֌W
	fk_AudioStream		bgm;
	fk_AudioWavBuffer	se0, se1, se3D;
	bool				bgm_play, se0_play, se1_play, se3D_play;

	if(!bgm.open("BGM\\stage_01.ogg")) {
		fl_alert("open() failed.");	// ǂݍ݂ɎsG[bZ[Wo
	}
	bgm.setLoopMode(true);

	se0.open("drum\\BDTIGHT2.wav");
	se1.open("drum\\SDCRKRM.wav");
	se3D.open("SE\\iPhone.wav");
	se3D.setLoopMode(true);
	// se3D.setPosition(fk_Vector(0.0, 0.0, 0.0));
	se3D.setModel(baseModel);
	se3D.setReferenceDist(100.0);
	se3D.setListenerModel(camera);

	bgm_play = false;
	se0_play = false;
	se1_play = false;
	se3D_play = false;
	// TEh֌W܂

	// ԊǗp̕ϐ
	fk_Vector	vSpd, vPos;	// xxNgAʒu擾pϐ
	int			iState = 0;	// 0: ӂ, 1: ㏸, 2: ~

	// 邮OɁAϐp
	fk_Vector	vFwd;			// Oi\ϐ
	vFwd.set(0.0, 0.0, -1.0);	// ꂪOi

	int	iTripleTime = 0;		// 3{^C\ϐ
	// ϐ܂

	// 邮[
	while(window.update() == true) {
		// L[őOiށE
		if(window.getSpecialKeyStatus(FK_UP) == FKUT_SW_PRESS) {
			baseModel.loTranslate(vFwd);	// vFwd̕֐i
		}
		if(window.getSpecialKeyStatus(FK_DOWN) == FKUT_SW_PRESS) {
			baseModel.loTranslate(-vFwd);	// vFwdƔΕ֐i
		}
		if(window.getSpecialKeyStatus(FK_LEFT) == FKUT_SW_PRESS) {
			baseModel.loFocus(-0.1, 0.0, -1.0);
		}
		if(window.getSpecialKeyStatus(FK_RIGHT) == FKUT_SW_PRESS) {
			baseModel.loFocus(0.1, 0.0, -1.0);
		}
		// L[쏈܂

		// 3{[hVXe
		if(iTripleTime == 0) {	// ܂ʏԂ̂Ƃ
			// XL[3{[hɂ
			if(window.getKeyStatus('x') == FKUT_SW_DOWN) {
				iTripleTime = 300;		// c莞Ԃ5b(300t[)ɂ
				body.setMaterial(Red);	// Ԃ
				vFwd.z = -3.0;			// 3{ɂ
			}
		} else if(iTripleTime >= 1) {	// 3{^CȂ
			iTripleTime--;	// c莞Ԃ1t[炷
			if(iTripleTime == 0) {	// 炵ʎԏIȂ
				body.setMaterial(Yellow);	// Fɖ߂
				vFwd.z = -1.0;				// xɖ߂
			}
		}
		// 3{[hVXe܂

		// HWv
		if(iState == 0) {			// ʏ탂[h
			// zL[ꂽuԁA㏸[hֈڍs
			if(window.getKeyStatus('z') == FKUT_SW_DOWN) {
				iState = 1;
				vSpd.y = 8.0;		// Wv̏x^
			}
		} else if(iState == 1) {	// ㏸[h
			// xω([Iȏd͉x^)
			if(vSpd.y > 4.0) {
				// ̑x邤͂߂Ɍ炷
				vSpd.y -= 1.0;
			} else if(vSpd.y > 0.0) {
				// xȂȂ猸炷ʂ炷
				vSpd.y -= 0.5;
			} else {
				// xɔ]牺~[hֈڍs
				iState = 2;
			}
			// ωxɂăfړ
			baseModel.glTranslate(vSpd);
		} else if(iState == 2) {	// ~[h
			// xω([Iȏd͉x^)
			if(vSpd.y > -4.0) {
				// ̑xȂ͂߂ɉ
				vSpd.y -= 0.5;
			} else {
				// xȂĂ炫߂ɉ
				vSpd.y -= 1.0;
			}
			// ωxɂăfړ
			baseModel.glTranslate(vSpd);
			// Ƃ̓蔻菈
			vPos = baseModel.getPosition();	// ݈ʒuĂ
			if(vPos.y < 0.0) {				// ɂ߂荞ł
				vSpd.y = 0.0;				// xZbg
				vPos.y = 0.0;				// YW0.0ɌŒ
				baseModel.glMoveTo(vPos);	// Œ肵Wɋ]
				// ʏ탂[hֈڍs
				iState = 0;
			}
		}
		// Wv܂

		// TEh֌W
		// se0̃L[(a)ɂĐ
		if(window.getKeyStatus('a') == FKUT_SW_DOWN) {
			se0_play = true;
			se0.seek(0.0);
		}
		if(se0_play == true) se0_play = se0.play();
		// se1̃L[(s)ɂĐ
		if(window.getKeyStatus('s') == FKUT_SW_DOWN) {
			se1_play = true;
			se1.seek(0.0);
		}
		if(se1_play == true) se1_play = se1.play();

		// BGM̓Xy[XōĐƈꎞ~؂ւ
		if(window.getKeyStatus(' ') == FKUT_SW_DOWN) {
			if(bgm_play == true) {
				bgm_play = false;
				bgm.pause();
			} else {
				bgm_play = true;
			}
		}
		if(bgm_play == true) bgm_play = bgm.play();

		// ͏ɂ炸炵ςȂ
		se3D.play();
		// TEh֌W܂
	}
	// ꂳ܂ł

	return 0;
}
